"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSSR = useSSR;

var _context = require("./context");

var initializedLanguageOnce = false;
var initializedStoreOnce = false;

function useSSR(initialI18nStore, initialLanguage) {
  // only set this once
  if (initializedLanguageOnce && initializedStoreOnce) return;
  var i18n = (0, _context.getI18n)(); // nextjs / SSR: getting data from next.js or other ssr stack

  if (initialI18nStore && !initializedStoreOnce) {
    i18n.services.resourceStore.data = initialI18nStore;
    initializedStoreOnce = true;
  }

  if (initialLanguage && !initializedLanguageOnce) {
    i18n.changeLanguage(initialLanguage);
    initializedLanguageOnce = true;
  }
}